if not oUF then return end

local class = select(2, UnitClass"player")
local level = UnitLevel("player")
if class=="ROGUE" or class=="WARLOCK" or class=="WARRIOR" or class=="HUNTER" then return end

-- Locals
local bgr, bgg, bgb, bga
local borderr, borderg, borderb, bordera
local color, dtype
local UnitCanAttack = UnitCanAttack
local noatt = false
--[[ Make sure we use the correct spells based on player's level. ]]
--[[ This is where you can edit the modifier or the spells order. ]]
if class=="PRIEST" then --Cure Disease(14)-Abolish Disease(32), Dispel Magic(18)
	if level >= 14 and level < 32 then
		priest = "/cast [target=mouseover] Cure Disease"
	elseif level >= 18 and level < 32 then
		priest = "/cast [target=mouseover, modifier:shift] Cure Disease; Dispel Magic"
	elseif level >= 32 then
		priest = "/cast [target=mouseover, modifier:shift] Abolish Disease; Dispel Magic"
	else
		noatt = true
	end
elseif class=="SHAMAN" then --Cure Disease(22), Cure Poison(16)
	if level >= 16 and level < 22 then
		shaman = "/cast [target=mouseover] Cure Poison"
	elseif level >= 22 then
		shaman = "/cast [target=mouseover, modifier:shift] Cure Disease; Cure Poison"
	else
		noatt = true
	end
elseif class=="DRUID" then --Cure Poison(16)-Abolish Poison(26), Remove Curse(24)
	if level >= 16 and level < 24 then
		druid = "/cast [target=mouseover] Cure Poison"
	elseif level >= 24 and level < 26 then
		druid = "/cast [target=mouseover, modifier:shift] Remove Curse; Cure Poison"
	elseif level >= 26 then
		druid = "/cast [target=mouseover, modifier:shift] Remove Curse; Abolish Poison"
	else
		noatt = true
	end
elseif class=="MAGE" then --Remove Lesser Curse(18)
	if level >= 18 then
		mage = "/cast [target=mouseover] Remove Lesser Curse"
	else
		noatt = true
	end
elseif class=="PALADIN" then --Purify(8), Cleanse(42)
	if level >= 8 and level < 42 then
		paladin = "/cast [target=mouseover] Purify"
	elseif level >= 42 then
		paladin = "/cast [target=mouseover] Cleanse"
	else
		noatt = true
	end
end

local function SetTheDamnAttributes(frame)
	if(noatt) then return end
	frame:SetAttribute("*type5", "macro") -- Change *type5(mouse5) to... "*type3" = mouse3(mousewheel) or "*type4" = mouse4. **NOTE:type1 is for targeting and type2 for the units menu**
	local lowerclass = _G[string.lower(class)]
	frame:SetAttribute("macrotext", lowerclass)
end

-- apply the color
local function applyColor(frame)
	if(frame.dispeltex) then
		frame.dispeltex:SetTexture(color.r, color.g, color.b, color.a)
	else
		frame:SetBackdropColor(color.r, color.g, color.b, color.a)
		frame:SetBackdropBorderColor(color.r, color.g, color.b, color.a)
	end
end

-- remove the color
local function unapplyColor(frame)
	if(frame.dispeltex) then
		frame.dispeltex:SetTexture(0, 0, 0, 0)
	else
		frame:SetBackdropColor(bgr, bgg, bgb, bga)
		frame:SetBackdropBorderColor(borderr, borderg, borderb, bordera)
	end
end

-- check if the frame needs to be colored
local applyDispelColor = function(frame)
	if(frame.unit) then
		if(UnitCanCooperate("player", frame.unit)) then
			local dtype,_,_ = select(5, UnitDebuff(frame.unit, 1, 1))
			color = DebuffTypeColor[dtype or ""]
			if(color) then applyColor(frame)
			else unapplyColor(frame) end
		else unapplyColor(frame) end
	end
end

-- create a texture if no backdrop/border
local function applyTexture(frame)
	if(not frame.dispeltex) then
		dispeltex = frame:CreateTexture()
		dispeltex:SetPoint("TOPLEFT", frame, "TOPLEFT", -5, 5)
		dispeltex:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 5, -5)
		dispeltex:SetTexture(0,0,0,0)
		frame.dispeltex = dispeltex
	end
end

local func = function(frame)
	if(not frame.oufdc) then return end
	SetTheDamnAttributes(frame)
	if(not frame:GetBackdropColor()) then
		applyTexture(frame)
	else
		bgr, bgg, bgb, bga = frame:GetBackdropColor()
		borderr, borderg, borderb, bordera = frame:GetBackdropBorderColor()
	end
	local o, o2 = frame.PostUpdateHealth, frame.PostUpdatePower
	frame.PostUpdateHealth = function(...) if o then o(...) end applyDispelColor(frame) end
	frame.PostUpdatePower = function(...) if o2 then o2(...) end applyDispelColor(frame) end
end

-- enable oUF_DispelColor on frames that need it
for frame in pairs(oUF.objects) do func(frame) end
oUF:RegisterInitCallback(function(frame) func(frame) end)